require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_HARDIRQ_H)) {
    eval 'sub _ASM_IA64_HARDIRQ_H () {1;}' unless defined(&_ASM_IA64_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'linux/irq.ph';
    require 'asm/processor.ph';
    eval 'sub softirq_pending {
        my($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> &softirq_pending));
    }' unless defined(&softirq_pending);
    eval 'sub ksoftirqd_task {
        my($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> &ksoftirqd));
    }' unless defined(&ksoftirqd_task);
    eval 'sub irq_count {
        my($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> ($irq_stat->{f}->{irq_count})));
    }' unless defined(&irq_count);
    eval 'sub bh_count {
        my($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> ($irq_stat->{f}->{bh_count})));
    }' unless defined(&bh_count);
    eval 'sub syscall_count {
        my($cpu) = @_;
	    eval q();
    }' unless defined(&syscall_count);
    eval 'sub nmi_count {
        my($cpu) = @_;
	    eval q(0);
    }' unless defined(&nmi_count);
    eval 'sub local_softirq_pending () {
        eval q(( ($local_cpu_data->{softirq_pending})));
    }' unless defined(&local_softirq_pending);
    eval 'sub local_ksoftirqd_task () {
        eval q(( ($local_cpu_data->{ksoftirqd})));
    }' unless defined(&local_ksoftirqd_task);
    eval 'sub local_irq_count () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{irq_count})));
    }' unless defined(&local_irq_count);
    eval 'sub local_bh_count () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{bh_count})));
    }' unless defined(&local_bh_count);
    eval 'sub local_syscall_count () {
        eval q();
    }' unless defined(&local_syscall_count);
    eval 'sub local_nmi_count () {
        eval q(0);
    }' unless defined(&local_nmi_count);
    eval 'sub in_interrupt () {
        eval q(( ($local_cpu_data->{irq_stat}->{irq_and_bh_counts}) != 0));
    }' unless defined(&in_interrupt);
    eval 'sub in_irq () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{irq_count}) != 0));
    }' unless defined(&in_irq);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub local_hardirq_trylock () {
	    eval q(( &local_irq_count() == 0));
	}' unless defined(&local_hardirq_trylock);
	eval 'sub local_hardirq_endlock () {
	    eval q( &do { }  &while (0));
	}' unless defined(&local_hardirq_endlock);
	eval 'sub local_irq_enter {
	    my($irq) = @_;
    	    eval q(( &local_irq_count()++));
	}' unless defined(&local_irq_enter);
	eval 'sub local_irq_exit {
	    my($irq) = @_;
    	    eval q(( &local_irq_count()--));
	}' unless defined(&local_irq_exit);
	eval 'sub synchronize_irq () {
	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    } else {
	require 'asm/atomic.ph';
	require 'asm/smp.ph';
	eval 'sub irqs_running {
	    my($void) = @_;
    	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &smp_num_cpus;  &i++)  &if ( &irq_count( &i)) 1; 0; });
	}' unless defined(&irqs_running);
	eval 'sub release_irqlock {
	    my($cpu) = @_;
    	    eval q({  &if ( &global_irq_holder == $cpu) {  &global_irq_holder =  &NO_PROC_ID;  &clear_bit(0, &global_irq_lock); } });
	}' unless defined(&release_irqlock);
	eval 'sub local_irq_enter {
	    my($irq) = @_;
    	    eval q({  &local_irq_count()++;  &while ( &test_bit(0, &global_irq_lock)) { ; } });
	}' unless defined(&local_irq_enter);
	eval 'sub local_irq_exit {
	    my($irq) = @_;
    	    eval q({  &local_irq_count()--; });
	}' unless defined(&local_irq_exit);
	eval 'sub local_hardirq_trylock {
	    my($void) = @_;
    	    eval q({ ! &local_irq_count()  && ! &test_bit(0, &global_irq_lock); });
	}' unless defined(&local_hardirq_trylock);
	eval 'sub local_hardirq_endlock () {
	    eval q( &do { }  &while (0));
	}' unless defined(&local_hardirq_endlock);
    }
}
1;
