require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_MACHVEC_H)) {
    eval 'sub _ASM_IA64_MACHVEC_H () {1;}' unless defined(&_ASM_IA64_MACHVEC_H);
    require 'linux/config.ph';
    require 'linux/types.ph';
    if(defined ( &CONFIG_IA64_HP_SIM)) {
	require 'asm/machvec_hpsim.ph';
    }
 elsif(defined ( &CONFIG_IA64_DIG)) {
	require 'asm/machvec_dig.ph';
    }
 elsif(defined ( &CONFIG_IA64_SGI_SN1)) {
	require 'asm/machvec_sn1.ph';
    }
 elsif(defined ( &CONFIG_IA64_GENERIC)) {
	if(defined(&MACHVEC_PLATFORM_HEADER)) {
	} else {
	    eval 'sub platform_name () { ($ia64_mv->{name});}' unless defined(&platform_name);
	    eval 'sub platform_setup () { ($ia64_mv->{setup});}' unless defined(&platform_setup);
	    eval 'sub platform_irq_init () { ($ia64_mv->{irq_init});}' unless defined(&platform_irq_init);
	    eval 'sub platform_map_nr () { ($ia64_mv->{map_nr});}' unless defined(&platform_map_nr);
	    eval 'sub platform_mca_init () { ($ia64_mv->{mca_init});}' unless defined(&platform_mca_init);
	    eval 'sub platform_mca_handler () { ($ia64_mv->{mca_handler});}' unless defined(&platform_mca_handler);
	    eval 'sub platform_cmci_handler () { ($ia64_mv->{cmci_handler});}' unless defined(&platform_cmci_handler);
	    eval 'sub platform_log_print () { ($ia64_mv->{log_print});}' unless defined(&platform_log_print);
	    eval 'sub platform_pci_fixup () { ($ia64_mv->{pci_fixup});}' unless defined(&platform_pci_fixup);
	    eval 'sub platform_send_ipi () { ($ia64_mv->{send_ipi});}' unless defined(&platform_send_ipi);
	    eval 'sub platform_pci_dma_init () { ($ia64_mv->{dma_init});}' unless defined(&platform_pci_dma_init);
	    eval 'sub platform_pci_alloc_consistent () { ($ia64_mv->{alloc_consistent});}' unless defined(&platform_pci_alloc_consistent);
	    eval 'sub platform_pci_free_consistent () { ($ia64_mv->{free_consistent});}' unless defined(&platform_pci_free_consistent);
	    eval 'sub platform_pci_map_single () { ($ia64_mv->{map_single});}' unless defined(&platform_pci_map_single);
	    eval 'sub platform_pci_unmap_single () { ($ia64_mv->{unmap_single});}' unless defined(&platform_pci_unmap_single);
	    eval 'sub platform_pci_map_sg () { ($ia64_mv->{map_sg});}' unless defined(&platform_pci_map_sg);
	    eval 'sub platform_pci_unmap_sg () { ($ia64_mv->{unmap_sg});}' unless defined(&platform_pci_unmap_sg);
	    eval 'sub platform_pci_dma_sync_single () { ($ia64_mv->{sync_single});}' unless defined(&platform_pci_dma_sync_single);
	    eval 'sub platform_pci_dma_sync_sg () { ($ia64_mv->{sync_sg});}' unless defined(&platform_pci_dma_sync_sg);
	    eval 'sub platform_pci_dma_address () { ($ia64_mv->{dma_address});}' unless defined(&platform_pci_dma_address);
	    eval 'sub platform_irq_desc () { ($ia64_mv->{irq_desc});}' unless defined(&platform_irq_desc);
	    eval 'sub platform_irq_to_vector () { ($ia64_mv->{irq_to_vector});}' unless defined(&platform_irq_to_vector);
	    eval 'sub platform_local_vector_to_irq () { ($ia64_mv->{local_vector_to_irq});}' unless defined(&platform_local_vector_to_irq);
	    eval 'sub platform_inb () { ($ia64_mv->{inb});}' unless defined(&platform_inb);
	    eval 'sub platform_inw () { ($ia64_mv->{inw});}' unless defined(&platform_inw);
	    eval 'sub platform_inl () { ($ia64_mv->{inl});}' unless defined(&platform_inl);
	    eval 'sub platform_outb () { ($ia64_mv->{outb});}' unless defined(&platform_outb);
	    eval 'sub platform_outw () { ($ia64_mv->{outw});}' unless defined(&platform_outw);
	    eval 'sub platform_outl () { ($ia64_mv->{outl});}' unless defined(&platform_outl);
	}
	eval 'sub MACHVEC_INIT {
	    my($name) = @_;
    	    eval q({ $name,  &platform_setup,  &platform_irq_init,  &platform_pci_fixup,  &platform_map_nr,  &platform_mca_init,  &platform_mca_handler,  &platform_cmci_handler,  &platform_log_print,  &platform_send_ipi,  &platform_pci_dma_init,  &platform_pci_alloc_consistent,  &platform_pci_free_consistent,  &platform_pci_map_single,  &platform_pci_unmap_single,  &platform_pci_map_sg,  &platform_pci_unmap_sg,  &platform_pci_dma_sync_single,  &platform_pci_dma_sync_sg,  &platform_pci_dma_address,  &platform_irq_desc,  &platform_irq_to_vector,  &platform_local_vector_to_irq,  &platform_inb,  &platform_inw,  &platform_inl,  &platform_outb,  &platform_outw,  &platform_outl });
	}' unless defined(&MACHVEC_INIT);
    } else {
	die("Unknown\ configuration\.\ \ Update\ asm\-ia64\/machvec\.h\.");
    }
    unless(defined(&platform_setup)) {
	eval 'sub platform_setup () {(( &ia64_mv_setup_t *)  &machvec_noop);}' unless defined(&platform_setup);
    }
    unless(defined(&platform_irq_init)) {
	eval 'sub platform_irq_init () {(( &ia64_mv_irq_init_t *)  &machvec_noop);}' unless defined(&platform_irq_init);
    }
    unless(defined(&platform_mca_init)) {
	eval 'sub platform_mca_init () {(( &ia64_mv_mca_init_t *)  &machvec_noop);}' unless defined(&platform_mca_init);
    }
    unless(defined(&platform_mca_handler)) {
	eval 'sub platform_mca_handler () {(( &ia64_mv_mca_handler_t *)  &machvec_noop);}' unless defined(&platform_mca_handler);
    }
    unless(defined(&platform_cmci_handler)) {
	eval 'sub platform_cmci_handler () {(( &ia64_mv_cmci_handler_t *)  &machvec_noop);}' unless defined(&platform_cmci_handler);
    }
    unless(defined(&platform_log_print)) {
	eval 'sub platform_log_print () {(( &ia64_mv_log_print_t *)  &machvec_noop);}' unless defined(&platform_log_print);
    }
    unless(defined(&platform_pci_fixup)) {
	eval 'sub platform_pci_fixup () {(( &ia64_mv_pci_fixup_t *)  &machvec_noop);}' unless defined(&platform_pci_fixup);
    }
    unless(defined(&platform_send_ipi)) {
	eval 'sub platform_send_ipi () { &ia64_send_ipi;}' unless defined(&platform_send_ipi);
    }
    unless(defined(&platform_pci_dma_init)) {
	eval 'sub platform_pci_dma_init () { &swiotlb_init;}' unless defined(&platform_pci_dma_init);
    }
    unless(defined(&platform_pci_alloc_consistent)) {
	eval 'sub platform_pci_alloc_consistent () { &swiotlb_alloc_consistent;}' unless defined(&platform_pci_alloc_consistent);
    }
    unless(defined(&platform_pci_free_consistent)) {
	eval 'sub platform_pci_free_consistent () { &swiotlb_free_consistent;}' unless defined(&platform_pci_free_consistent);
    }
    unless(defined(&platform_pci_map_single)) {
	eval 'sub platform_pci_map_single () { &swiotlb_map_single;}' unless defined(&platform_pci_map_single);
    }
    unless(defined(&platform_pci_unmap_single)) {
	eval 'sub platform_pci_unmap_single () { &swiotlb_unmap_single;}' unless defined(&platform_pci_unmap_single);
    }
    unless(defined(&platform_pci_map_sg)) {
	eval 'sub platform_pci_map_sg () { &swiotlb_map_sg;}' unless defined(&platform_pci_map_sg);
    }
    unless(defined(&platform_pci_unmap_sg)) {
	eval 'sub platform_pci_unmap_sg () { &swiotlb_unmap_sg;}' unless defined(&platform_pci_unmap_sg);
    }
    unless(defined(&platform_pci_dma_sync_single)) {
	eval 'sub platform_pci_dma_sync_single () { &swiotlb_sync_single;}' unless defined(&platform_pci_dma_sync_single);
    }
    unless(defined(&platform_pci_dma_sync_sg)) {
	eval 'sub platform_pci_dma_sync_sg () { &swiotlb_sync_sg;}' unless defined(&platform_pci_dma_sync_sg);
    }
    unless(defined(&platform_pci_dma_address)) {
	eval 'sub platform_pci_dma_address () { &swiotlb_dma_address;}' unless defined(&platform_pci_dma_address);
    }
    unless(defined(&platform_irq_desc)) {
	eval 'sub platform_irq_desc () { &__ia64_irq_desc;}' unless defined(&platform_irq_desc);
    }
    unless(defined(&platform_irq_to_vector)) {
	eval 'sub platform_irq_to_vector () { &__ia64_irq_to_vector;}' unless defined(&platform_irq_to_vector);
    }
    unless(defined(&platform_local_vector_to_irq)) {
	eval 'sub platform_local_vector_to_irq () { &__ia64_local_vector_to_irq;}' unless defined(&platform_local_vector_to_irq);
    }
    unless(defined(&platform_inb)) {
	eval 'sub platform_inb () { &__ia64_inb;}' unless defined(&platform_inb);
    }
    unless(defined(&platform_inw)) {
	eval 'sub platform_inw () { &__ia64_inw;}' unless defined(&platform_inw);
    }
    unless(defined(&platform_inl)) {
	eval 'sub platform_inl () { &__ia64_inl;}' unless defined(&platform_inl);
    }
    unless(defined(&platform_outb)) {
	eval 'sub platform_outb () { &__ia64_outb;}' unless defined(&platform_outb);
    }
    unless(defined(&platform_outw)) {
	eval 'sub platform_outw () { &__ia64_outw;}' unless defined(&platform_outw);
    }
    unless(defined(&platform_outl)) {
	eval 'sub platform_outl () { &__ia64_outl;}' unless defined(&platform_outl);
    }
}
1;
