require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PGALLOC_H)) {
    eval 'sub _ASM_IA64_PGALLOC_H () {1;}' unless defined(&_ASM_IA64_PGALLOC_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'asm/mmu_context.ph';
    require 'asm/processor.ph';
    eval 'sub pgd_quicklist () {( ($local_cpu_data->{pgd_quick}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {( ($local_cpu_data->{pmd_quick}));}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($local_cpu_data->{pte_quick}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($local_cpu_data->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub pgd_alloc_one_fast {
        my($mm) = @_;
	    eval q({ my $long * &ret =  &pgd_quicklist;  &if ( &__builtin_expect( &ret !=  &NULL, 1)) {  &pgd_quicklist = (* &ret);  $ret[0] = 0; -- &pgtable_cache_size; }  &else  &ret =  &NULL; ( &pgd_t *)  &ret; });
    }' unless defined(&pgd_alloc_one_fast);
    eval 'sub pgd_alloc {
        my($mm) = @_;
	    eval q({  &pgd_t * &pgd =  &pgd_alloc_one_fast($mm);  &if ( &__builtin_expect( &pgd ==  &NULL, 0)) {  &pgd = ( &pgd_t *) &__get_free_page( &GFP_KERNEL);  &if ( &__builtin_expect( &pgd !=  &NULL, 1))  &clear_page( &pgd); }  &pgd; });
    }' unless defined(&pgd_alloc);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q({ *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd; ++ &pgtable_cache_size; });
    }' unless defined(&pgd_free);
    eval 'sub pgd_populate {
        my($mm,$pgd_entry,$pmd) = @_;
	    eval q({  &pgd_val(*$pgd_entry) =  &__pa($pmd); });
    }' unless defined(&pgd_populate);
    eval 'sub pmd_alloc_one_fast {
        my($mm,$addr) = @_;
	    eval q({ my $long * &ret =  &pmd_quicklist;  &if ( &__builtin_expect( &ret !=  &NULL, 1)) {  &pmd_quicklist = (* &ret);  $ret[0] = 0; -- &pgtable_cache_size; } ( &pmd_t *) &ret; });
    }' unless defined(&pmd_alloc_one_fast);
    eval 'sub pmd_alloc_one {
        my($mm,$addr) = @_;
	    eval q({  &pmd_t * &pmd = ( &pmd_t *)  &__get_free_page( &GFP_KERNEL);  &if ( &__builtin_expect( &pmd !=  &NULL, 1))  &clear_page( &pmd);  &pmd; });
    }' unless defined(&pmd_alloc_one);
    eval 'sub pmd_free {
        my($pmd) = @_;
	    eval q({ *$pmd =  &pmd_quicklist;  &pmd_quicklist = $pmd; ++ &pgtable_cache_size; });
    }' unless defined(&pmd_free);
    eval 'sub pmd_populate {
        my($mm,$pmd_entry,$pte) = @_;
	    eval q({  &pmd_val(*$pmd_entry) =  &__pa($pte); });
    }' unless defined(&pmd_populate);
    eval 'sub pte_alloc_one_fast {
        my($mm,$addr) = @_;
	    eval q({ my $long * &ret =  &pte_quicklist;  &if ( &__builtin_expect( &ret !=  &NULL, 1)) {  &pte_quicklist = (* &ret);  $ret[0] = 0; -- &pgtable_cache_size; } ( &pte_t *) &ret; });
    }' unless defined(&pte_alloc_one_fast);
    eval 'sub pte_alloc_one {
        my($mm,$addr) = @_;
	    eval q({  &pte_t * &pte = ( &pte_t *)  &__get_free_page( &GFP_KERNEL);  &if ( &__builtin_expect( &pte !=  &NULL, 1))  &clear_page( &pte);  &pte; });
    }' unless defined(&pte_alloc_one);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q({ *$pte =  &pte_quicklist;  &pte_quicklist = $pte; ++ &pgtable_cache_size; });
    }' unless defined(&pte_free);
    if(defined(&CONFIG_SMP)) {
	eval 'sub flush_tlb_all () {
	    eval q( &smp_flush_tlb_all());
	}' unless defined(&flush_tlb_all);
    } else {
	eval 'sub flush_tlb_all () {
	    eval q( &__flush_tlb_all());
	}' unless defined(&flush_tlb_all);
    }
    if(defined(&CONFIG_SMP)) {
    } else {
    }
    eval 'sub flush_cache_all () {
        eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_all);
    eval 'sub flush_cache_mm {
        my($mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_mm);
    eval 'sub flush_cache_range {
        my($mm, $start, $end) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_range);
    eval 'sub flush_cache_page {
        my($vma, $vmaddr) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_page);
    eval 'sub flush_page_to_ram {
        my($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_page_to_ram);
    eval 'sub flush_dcache_page {
        my($page) = @_;
	    eval q({  &clear_bit( &PG_arch_1,  ($page->{flags})); });
    }' unless defined(&flush_dcache_page);
    eval 'sub clear_user_page {
        my($addr,$vaddr,$page) = @_;
	    eval q({  &clear_page($addr);  &flush_dcache_page($page); });
    }' unless defined(&clear_user_page);
    eval 'sub copy_user_page {
        my($to,$from,$vaddr,$page) = @_;
	    eval q({  &copy_page($to, $from);  &flush_dcache_page($page); });
    }' unless defined(&copy_user_page);
}
1;
