require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PROCESSOR_H)) {
    eval 'sub _ASM_IA64_PROCESSOR_H () {1;}' unless defined(&_ASM_IA64_PROCESSOR_H);
    require 'linux/config.ph';
    require 'asm/ptrace.ph';
    require 'asm/kregs.ph';
    require 'asm/system.ph';
    require 'asm/types.ph';
    eval 'sub IA64_NUM_DBG_REGS () {8;}' unless defined(&IA64_NUM_DBG_REGS);
    eval 'sub IA64_NUM_PMC_REGS () {32;}' unless defined(&IA64_NUM_PMC_REGS);
    eval 'sub IA64_NUM_PMD_REGS () {32;}' unless defined(&IA64_NUM_PMD_REGS);
    eval 'sub IA64_NUM_PMD_COUNTERS () {4;}' unless defined(&IA64_NUM_PMD_COUNTERS);
    eval 'sub DEFAULT_MAP_BASE () {0x2000000000000000;}' unless defined(&DEFAULT_MAP_BASE);
    eval 'sub DEFAULT_TASK_SIZE () {0xa000000000000000;}' unless defined(&DEFAULT_TASK_SIZE);
    eval 'sub TASK_SIZE () {( ($current->{thread}->{task_size}));}' unless defined(&TASK_SIZE);
    eval 'sub TASK_UNMAPPED_BASE () {( ($current->{thread}->{map_base}));}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub EISA_bus () {0;}' unless defined(&EISA_bus);
    eval 'sub EISA_bus__is_a_macro () {1;}' unless defined(&EISA_bus__is_a_macro);
    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
    eval 'sub IA64_PSR_BE_BIT () {1;}' unless defined(&IA64_PSR_BE_BIT);
    eval 'sub IA64_PSR_UP_BIT () {2;}' unless defined(&IA64_PSR_UP_BIT);
    eval 'sub IA64_PSR_AC_BIT () {3;}' unless defined(&IA64_PSR_AC_BIT);
    eval 'sub IA64_PSR_MFL_BIT () {4;}' unless defined(&IA64_PSR_MFL_BIT);
    eval 'sub IA64_PSR_MFH_BIT () {5;}' unless defined(&IA64_PSR_MFH_BIT);
    eval 'sub IA64_PSR_IC_BIT () {13;}' unless defined(&IA64_PSR_IC_BIT);
    eval 'sub IA64_PSR_I_BIT () {14;}' unless defined(&IA64_PSR_I_BIT);
    eval 'sub IA64_PSR_PK_BIT () {15;}' unless defined(&IA64_PSR_PK_BIT);
    eval 'sub IA64_PSR_DT_BIT () {17;}' unless defined(&IA64_PSR_DT_BIT);
    eval 'sub IA64_PSR_DFL_BIT () {18;}' unless defined(&IA64_PSR_DFL_BIT);
    eval 'sub IA64_PSR_DFH_BIT () {19;}' unless defined(&IA64_PSR_DFH_BIT);
    eval 'sub IA64_PSR_SP_BIT () {20;}' unless defined(&IA64_PSR_SP_BIT);
    eval 'sub IA64_PSR_PP_BIT () {21;}' unless defined(&IA64_PSR_PP_BIT);
    eval 'sub IA64_PSR_DI_BIT () {22;}' unless defined(&IA64_PSR_DI_BIT);
    eval 'sub IA64_PSR_SI_BIT () {23;}' unless defined(&IA64_PSR_SI_BIT);
    eval 'sub IA64_PSR_DB_BIT () {24;}' unless defined(&IA64_PSR_DB_BIT);
    eval 'sub IA64_PSR_LP_BIT () {25;}' unless defined(&IA64_PSR_LP_BIT);
    eval 'sub IA64_PSR_TB_BIT () {26;}' unless defined(&IA64_PSR_TB_BIT);
    eval 'sub IA64_PSR_RT_BIT () {27;}' unless defined(&IA64_PSR_RT_BIT);
    eval 'sub IA64_PSR_CPL0_BIT () {32;}' unless defined(&IA64_PSR_CPL0_BIT);
    eval 'sub IA64_PSR_CPL1_BIT () {33;}' unless defined(&IA64_PSR_CPL1_BIT);
    eval 'sub IA64_PSR_IS_BIT () {34;}' unless defined(&IA64_PSR_IS_BIT);
    eval 'sub IA64_PSR_MC_BIT () {35;}' unless defined(&IA64_PSR_MC_BIT);
    eval 'sub IA64_PSR_IT_BIT () {36;}' unless defined(&IA64_PSR_IT_BIT);
    eval 'sub IA64_PSR_ID_BIT () {37;}' unless defined(&IA64_PSR_ID_BIT);
    eval 'sub IA64_PSR_DA_BIT () {38;}' unless defined(&IA64_PSR_DA_BIT);
    eval 'sub IA64_PSR_DD_BIT () {39;}' unless defined(&IA64_PSR_DD_BIT);
    eval 'sub IA64_PSR_SS_BIT () {40;}' unless defined(&IA64_PSR_SS_BIT);
    eval 'sub IA64_PSR_RI_BIT () {41;}' unless defined(&IA64_PSR_RI_BIT);
    eval 'sub IA64_PSR_ED_BIT () {43;}' unless defined(&IA64_PSR_ED_BIT);
    eval 'sub IA64_PSR_BN_BIT () {44;}' unless defined(&IA64_PSR_BN_BIT);
    eval 'sub IA64_PSR_BE () {( &__IA64_UL(1) <<  &IA64_PSR_BE_BIT);}' unless defined(&IA64_PSR_BE);
    eval 'sub IA64_PSR_UP () {( &__IA64_UL(1) <<  &IA64_PSR_UP_BIT);}' unless defined(&IA64_PSR_UP);
    eval 'sub IA64_PSR_AC () {( &__IA64_UL(1) <<  &IA64_PSR_AC_BIT);}' unless defined(&IA64_PSR_AC);
    eval 'sub IA64_PSR_MFL () {( &__IA64_UL(1) <<  &IA64_PSR_MFL_BIT);}' unless defined(&IA64_PSR_MFL);
    eval 'sub IA64_PSR_MFH () {( &__IA64_UL(1) <<  &IA64_PSR_MFH_BIT);}' unless defined(&IA64_PSR_MFH);
    eval 'sub IA64_PSR_IC () {( &__IA64_UL(1) <<  &IA64_PSR_IC_BIT);}' unless defined(&IA64_PSR_IC);
    eval 'sub IA64_PSR_I () {( &__IA64_UL(1) <<  &IA64_PSR_I_BIT);}' unless defined(&IA64_PSR_I);
    eval 'sub IA64_PSR_PK () {( &__IA64_UL(1) <<  &IA64_PSR_PK_BIT);}' unless defined(&IA64_PSR_PK);
    eval 'sub IA64_PSR_DT () {( &__IA64_UL(1) <<  &IA64_PSR_DT_BIT);}' unless defined(&IA64_PSR_DT);
    eval 'sub IA64_PSR_DFL () {( &__IA64_UL(1) <<  &IA64_PSR_DFL_BIT);}' unless defined(&IA64_PSR_DFL);
    eval 'sub IA64_PSR_DFH () {( &__IA64_UL(1) <<  &IA64_PSR_DFH_BIT);}' unless defined(&IA64_PSR_DFH);
    eval 'sub IA64_PSR_SP () {( &__IA64_UL(1) <<  &IA64_PSR_SP_BIT);}' unless defined(&IA64_PSR_SP);
    eval 'sub IA64_PSR_PP () {( &__IA64_UL(1) <<  &IA64_PSR_PP_BIT);}' unless defined(&IA64_PSR_PP);
    eval 'sub IA64_PSR_DI () {( &__IA64_UL(1) <<  &IA64_PSR_DI_BIT);}' unless defined(&IA64_PSR_DI);
    eval 'sub IA64_PSR_SI () {( &__IA64_UL(1) <<  &IA64_PSR_SI_BIT);}' unless defined(&IA64_PSR_SI);
    eval 'sub IA64_PSR_DB () {( &__IA64_UL(1) <<  &IA64_PSR_DB_BIT);}' unless defined(&IA64_PSR_DB);
    eval 'sub IA64_PSR_LP () {( &__IA64_UL(1) <<  &IA64_PSR_LP_BIT);}' unless defined(&IA64_PSR_LP);
    eval 'sub IA64_PSR_TB () {( &__IA64_UL(1) <<  &IA64_PSR_TB_BIT);}' unless defined(&IA64_PSR_TB);
    eval 'sub IA64_PSR_RT () {( &__IA64_UL(1) <<  &IA64_PSR_RT_BIT);}' unless defined(&IA64_PSR_RT);
    eval 'sub IA64_PSR_IS () {( &__IA64_UL(1) <<  &IA64_PSR_IS_BIT);}' unless defined(&IA64_PSR_IS);
    eval 'sub IA64_PSR_MC () {( &__IA64_UL(1) <<  &IA64_PSR_MC_BIT);}' unless defined(&IA64_PSR_MC);
    eval 'sub IA64_PSR_IT () {( &__IA64_UL(1) <<  &IA64_PSR_IT_BIT);}' unless defined(&IA64_PSR_IT);
    eval 'sub IA64_PSR_ID () {( &__IA64_UL(1) <<  &IA64_PSR_ID_BIT);}' unless defined(&IA64_PSR_ID);
    eval 'sub IA64_PSR_DA () {( &__IA64_UL(1) <<  &IA64_PSR_DA_BIT);}' unless defined(&IA64_PSR_DA);
    eval 'sub IA64_PSR_DD () {( &__IA64_UL(1) <<  &IA64_PSR_DD_BIT);}' unless defined(&IA64_PSR_DD);
    eval 'sub IA64_PSR_SS () {( &__IA64_UL(1) <<  &IA64_PSR_SS_BIT);}' unless defined(&IA64_PSR_SS);
    eval 'sub IA64_PSR_RI () {( &__IA64_UL(3) <<  &IA64_PSR_RI_BIT);}' unless defined(&IA64_PSR_RI);
    eval 'sub IA64_PSR_ED () {( &__IA64_UL(1) <<  &IA64_PSR_ED_BIT);}' unless defined(&IA64_PSR_ED);
    eval 'sub IA64_PSR_BN () {( &__IA64_UL(1) <<  &IA64_PSR_BN_BIT);}' unless defined(&IA64_PSR_BN);
    eval 'sub IA64_PSR_UM () {( &IA64_PSR_BE |  &IA64_PSR_UP |  &IA64_PSR_AC |  &IA64_PSR_MFL |  &IA64_PSR_MFH);}' unless defined(&IA64_PSR_UM);
    eval 'sub IA64_DCR_PP_BIT () {0;}' unless defined(&IA64_DCR_PP_BIT);
    eval 'sub IA64_DCR_BE_BIT () {1;}' unless defined(&IA64_DCR_BE_BIT);
    eval 'sub IA64_DCR_LC_BIT () {2;}' unless defined(&IA64_DCR_LC_BIT);
    eval 'sub IA64_DCR_DM_BIT () {8;}' unless defined(&IA64_DCR_DM_BIT);
    eval 'sub IA64_DCR_DP_BIT () {9;}' unless defined(&IA64_DCR_DP_BIT);
    eval 'sub IA64_DCR_DK_BIT () {10;}' unless defined(&IA64_DCR_DK_BIT);
    eval 'sub IA64_DCR_DX_BIT () {11;}' unless defined(&IA64_DCR_DX_BIT);
    eval 'sub IA64_DCR_DR_BIT () {12;}' unless defined(&IA64_DCR_DR_BIT);
    eval 'sub IA64_DCR_DA_BIT () {13;}' unless defined(&IA64_DCR_DA_BIT);
    eval 'sub IA64_DCR_DD_BIT () {14;}' unless defined(&IA64_DCR_DD_BIT);
    eval 'sub IA64_DCR_PP () {( &__IA64_UL(1) <<  &IA64_DCR_PP_BIT);}' unless defined(&IA64_DCR_PP);
    eval 'sub IA64_DCR_BE () {( &__IA64_UL(1) <<  &IA64_DCR_BE_BIT);}' unless defined(&IA64_DCR_BE);
    eval 'sub IA64_DCR_LC () {( &__IA64_UL(1) <<  &IA64_DCR_LC_BIT);}' unless defined(&IA64_DCR_LC);
    eval 'sub IA64_DCR_DM () {( &__IA64_UL(1) <<  &IA64_DCR_DM_BIT);}' unless defined(&IA64_DCR_DM);
    eval 'sub IA64_DCR_DP () {( &__IA64_UL(1) <<  &IA64_DCR_DP_BIT);}' unless defined(&IA64_DCR_DP);
    eval 'sub IA64_DCR_DK () {( &__IA64_UL(1) <<  &IA64_DCR_DK_BIT);}' unless defined(&IA64_DCR_DK);
    eval 'sub IA64_DCR_DX () {( &__IA64_UL(1) <<  &IA64_DCR_DX_BIT);}' unless defined(&IA64_DCR_DX);
    eval 'sub IA64_DCR_DR () {( &__IA64_UL(1) <<  &IA64_DCR_DR_BIT);}' unless defined(&IA64_DCR_DR);
    eval 'sub IA64_DCR_DA () {( &__IA64_UL(1) <<  &IA64_DCR_DA_BIT);}' unless defined(&IA64_DCR_DA);
    eval 'sub IA64_DCR_DD () {( &__IA64_UL(1) <<  &IA64_DCR_DD_BIT);}' unless defined(&IA64_DCR_DD);
    eval 'sub IA64_ISR_X_BIT () {32;}' unless defined(&IA64_ISR_X_BIT);
    eval 'sub IA64_ISR_W_BIT () {33;}' unless defined(&IA64_ISR_W_BIT);
    eval 'sub IA64_ISR_R_BIT () {34;}' unless defined(&IA64_ISR_R_BIT);
    eval 'sub IA64_ISR_NA_BIT () {35;}' unless defined(&IA64_ISR_NA_BIT);
    eval 'sub IA64_ISR_SP_BIT () {36;}' unless defined(&IA64_ISR_SP_BIT);
    eval 'sub IA64_ISR_RS_BIT () {37;}' unless defined(&IA64_ISR_RS_BIT);
    eval 'sub IA64_ISR_IR_BIT () {38;}' unless defined(&IA64_ISR_IR_BIT);
    eval 'sub IA64_ISR_X () {( &__IA64_UL(1) <<  &IA64_ISR_X_BIT);}' unless defined(&IA64_ISR_X);
    eval 'sub IA64_ISR_W () {( &__IA64_UL(1) <<  &IA64_ISR_W_BIT);}' unless defined(&IA64_ISR_W);
    eval 'sub IA64_ISR_R () {( &__IA64_UL(1) <<  &IA64_ISR_R_BIT);}' unless defined(&IA64_ISR_R);
    eval 'sub IA64_ISR_NA () {( &__IA64_UL(1) <<  &IA64_ISR_NA_BIT);}' unless defined(&IA64_ISR_NA);
    eval 'sub IA64_ISR_SP () {( &__IA64_UL(1) <<  &IA64_ISR_SP_BIT);}' unless defined(&IA64_ISR_SP);
    eval 'sub IA64_ISR_RS () {( &__IA64_UL(1) <<  &IA64_ISR_RS_BIT);}' unless defined(&IA64_ISR_RS);
    eval 'sub IA64_ISR_IR () {( &__IA64_UL(1) <<  &IA64_ISR_IR_BIT);}' unless defined(&IA64_ISR_IR);
    eval 'sub IA64_THREAD_FPH_VALID () {( &__IA64_UL(1) << 0);}' unless defined(&IA64_THREAD_FPH_VALID);
    eval 'sub IA64_THREAD_DBG_VALID () {( &__IA64_UL(1) << 1);}' unless defined(&IA64_THREAD_DBG_VALID);
    eval 'sub IA64_THREAD_PM_VALID () {( &__IA64_UL(1) << 2);}' unless defined(&IA64_THREAD_PM_VALID);
    eval 'sub IA64_THREAD_UAC_NOPRINT () {( &__IA64_UL(1) << 3);}' unless defined(&IA64_THREAD_UAC_NOPRINT);
    eval 'sub IA64_THREAD_UAC_SIGBUS () {( &__IA64_UL(1) << 4);}' unless defined(&IA64_THREAD_UAC_SIGBUS);
    eval 'sub IA64_THREAD_KRBS_SYNCED () {( &__IA64_UL(1) << 5);}' unless defined(&IA64_THREAD_KRBS_SYNCED);
    eval 'sub IA64_KERNEL_DEATH () {( &__IA64_UL(1) << 63);}' unless defined(&IA64_KERNEL_DEATH);
    eval 'sub IA64_THREAD_UAC_SHIFT () {3;}' unless defined(&IA64_THREAD_UAC_SHIFT);
    eval 'sub IA64_THREAD_UAC_MASK () {( &IA64_THREAD_UAC_NOPRINT |  &IA64_THREAD_UAC_SIGBUS);}' unless defined(&IA64_THREAD_UAC_MASK);
    eval 'sub IA64_USEC_PER_CYC_SHIFT () {41;}' unless defined(&IA64_USEC_PER_CYC_SHIFT);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/threads.ph';
	require 'asm/fpu.ph';
	require 'asm/offsets.ph';
	require 'asm/page.ph';
	require 'asm/rse.ph';
	require 'asm/unwind.ph';
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_NUMA)) {
	}
	eval 'sub local_cpu_data () {(  &PERCPU_ADDR);}' unless defined(&local_cpu_data);
	if(defined(&CONFIG_NUMA)) {
	    eval 'sub cpu_data {
	        my($cpu) = @_;
    		eval q( ($local_cpu_data->{cpu_data_ptrs[$cpu]}));
	    }' unless defined(&cpu_data);
	} else {
	    eval 'sub cpu_data {
	        my($cpu) = @_;
    		eval q((& $_cpu_data[$cpu]));
	    }' unless defined(&cpu_data);
	}
	eval 'sub SET_UNALIGN_CTL {
	    my($task,$value) = @_;
    	    eval q(({ ($task)-> ($thread->{flags}) = ((($task)-> ($thread->{flags}) & ~ &IA64_THREAD_UAC_MASK) | ((($value) <<  &IA64_THREAD_UAC_SHIFT) &  &IA64_THREAD_UAC_MASK)); 0; }));
	}' unless defined(&SET_UNALIGN_CTL);
	eval 'sub GET_UNALIGN_CTL {
	    my($task,$addr) = @_;
    	    eval q(({  &put_user((-> ($thread->{flags}) &  &IA64_THREAD_UAC_MASK) >>  &IA64_THREAD_UAC_SHIFT, ($addr)); }));
	}' unless defined(&GET_UNALIGN_CTL);
	if(defined(&CONFIG_IA32_SUPPORT)) {
	    eval 'sub INIT_THREAD_IA32 () {0, 0, 0x17800000037f, 0, 0, 0, 0, 0, 0, {0},;}' unless defined(&INIT_THREAD_IA32);
	} else {
	    eval 'sub INIT_THREAD_IA32 () {1;}' unless defined(&INIT_THREAD_IA32);
	}
	if(defined(&CONFIG_PERFMON)) {
	    eval 'sub INIT_THREAD_PM () {{0, }, {0, }, 0, 0,;}' unless defined(&INIT_THREAD_PM);
	} else {
	    eval 'sub INIT_THREAD_PM () {1;}' unless defined(&INIT_THREAD_PM);
	}
	eval 'sub INIT_MMAP () {{  &init_mm,  &PAGE_OFFSET,  &PAGE_OFFSET + 0x10000000,  &NULL,  &PAGE_SHARED,  &VM_READ |  &VM_WRITE |  &VM_EXEC, 1,  &NULL,  &NULL };}' unless defined(&INIT_MMAP);
	eval 'sub INIT_THREAD () {{ 0, 0,  &DEFAULT_MAP_BASE,  &DEFAULT_TASK_SIZE, 0,  &INIT_THREAD_IA32  &INIT_THREAD_PM {0, }, {0, }, {{{{0}}}, } };}' unless defined(&INIT_THREAD);
	eval 'sub start_thread {
	    my($regs,$new_ip,$new_sp) = @_;
    	    eval q( &do {  &set_fs( &USER_DS);  &ia64_psr($regs)-> &dfh = 1;  &ia64_psr($regs)-> &mfh = 0;  &ia64_psr($regs)-> &cpl = 3;  &ia64_psr($regs)-> &ri = 0;  &ia64_psr($regs)-> &is = 0;  ($regs->{cr_iip}) = $new_ip;  ($regs->{ar_rsc}) = 0xf;  ($regs->{ar_rnat}) = 0;  ($regs->{ar_bspstore}) =  &IA64_RBS_BOT;  ($regs->{ar_fpsr}) =  &FPSR_DEFAULT;  ($regs->{loadrs}) = 0;  ($regs->{r8}) =  ($current->{mm}->{dumpable});  ($regs->{r12}) = $new_sp - 16;  &if (! &__builtin_expect ( ($current->{mm}->{dumpable}), 1)) {  ($regs->{ar_pfs}) = 0;  ($regs->{pr}) = 0;  ($regs->{b6}) = 0;  ($regs->{r1}) = 0;  ($regs->{r2}) = 0;  ($regs->{r3}) = 0;  ($regs->{r13}) = 0;  ($regs->{r14}) = 0;  ($regs->{r15}) = 0;  ($regs->{r9})  = 0;  ($regs->{r11}) = 0;  ($regs->{r16}) = 0;  ($regs->{r17}) = 0;  ($regs->{r18}) = 0;  ($regs->{r19}) = 0;  ($regs->{r20}) = 0;  ($regs->{r21}) = 0;  ($regs->{r22}) = 0;  ($regs->{r23}) = 0;  ($regs->{r24}) = 0;  ($regs->{r25}) = 0;  ($regs->{r26}) = 0;  ($regs->{r27}) = 0;  ($regs->{r28}) = 0;  ($regs->{r29}) = 0;  ($regs->{r30}) = 0;  ($regs->{r31}) = 0;  ($regs->{ar_ccv}) = 0;  ($regs->{b0}) = 0;  ($regs->{b7}) = 0;  ($regs->{f6}->{u}->{bits[0]}) = 0;  ($regs->{f6}->{u}->{bits[1]}) = 0;  ($regs->{f7}->{u}->{bits[0]}) = 0;  ($regs->{f7}->{u}->{bits[1]}) = 0;  ($regs->{f8}->{u}->{bits[0]}) = 0;  ($regs->{f8}->{u}->{bits[1]}) = 0;  ($regs->{f9}->{u}->{bits[0]}) = 0;  ($regs->{f9}->{u}->{bits[1]}) = 0; } }  &while (0));
	}' unless defined(&start_thread);
	if(defined(&CONFIG_PERFMON)) {
	} else {
	    eval 'sub release_thread {
	        my($dead_task) = @_;
    		eval q();
	    }' unless defined(&release_thread);
	}
	eval 'sub copy_segments {
	    my($tsk, $mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&copy_segments);
	eval 'sub release_segments {
	    my($mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&release_segments);
	eval 'sub KSTK_EIP {
	    my($tsk) = @_;
    	    eval q(({ \'struct pt_regs\' * &_regs =  &ia64_task_regs($tsk);  ($_regs->{cr_iip}) +  &ia64_psr( &_regs)-> &ri; }));
	}' unless defined(&KSTK_EIP);
	eval 'sub KSTK_ESP {
	    my($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{ksp})));
	}' unless defined(&KSTK_ESP);
	eval 'sub ia64_get_kr {
	    my($regnum) = @_;
    	    eval q({ my $r;  &switch ($regnum) {  &case 0:  &asm  &volatile (\\"mov %0=ar.k0\\" : \\"=r\\"( $r));  &break;  &case 1:  &asm  &volatile (\\"mov %0=ar.k1\\" : \\"=r\\"( $r));  &break;  &case 2:  &asm  &volatile (\\"mov %0=ar.k2\\" : \\"=r\\"( $r));  &break;  &case 3:  &asm  &volatile (\\"mov %0=ar.k3\\" : \\"=r\\"( $r));  &break;  &case 4:  &asm  &volatile (\\"mov %0=ar.k4\\" : \\"=r\\"( $r));  &break;  &case 5:  &asm  &volatile (\\"mov %0=ar.k5\\" : \\"=r\\"( $r));  &break;  &case 6:  &asm  &volatile (\\"mov %0=ar.k6\\" : \\"=r\\"( $r));  &break;  &case 7:  &asm  &volatile (\\"mov %0=ar.k7\\" : \\"=r\\"( $r));  &break; }  $r; });
	}' unless defined(&ia64_get_kr);
	eval 'sub ia64_set_kr {
	    my($regnum,$r) = @_;
    	    eval q({  &switch ($regnum) {  &case 0:  &asm  &volatile (\\"mov ar.k0=%0\\" :: \\"r\\"($r));  &break;  &case 1:  &asm  &volatile (\\"mov ar.k1=%0\\" :: \\"r\\"($r));  &break;  &case 2:  &asm  &volatile (\\"mov ar.k2=%0\\" :: \\"r\\"($r));  &break;  &case 3:  &asm  &volatile (\\"mov ar.k3=%0\\" :: \\"r\\"($r));  &break;  &case 4:  &asm  &volatile (\\"mov ar.k4=%0\\" :: \\"r\\"($r));  &break;  &case 5:  &asm  &volatile (\\"mov ar.k5=%0\\" :: \\"r\\"($r));  &break;  &case 6:  &asm  &volatile (\\"mov ar.k6=%0\\" :: \\"r\\"($r));  &break;  &case 7:  &asm  &volatile (\\"mov ar.k7=%0\\" :: \\"r\\"($r));  &break; } });
	}' unless defined(&ia64_set_kr);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub ia64_get_fpu_owner {
	        my($void) = @_;
    		eval q({   &ia64_get_kr( &IA64_KR_FPU_OWNER); });
	    }' unless defined(&ia64_get_fpu_owner);
	    eval 'sub ia64_set_fpu_owner {
	        my($t) = @_;
    		eval q({  &ia64_set_kr( &IA64_KR_FPU_OWNER, $t); });
	    }' unless defined(&ia64_set_fpu_owner);
	}
	if(defined(&CONFIG_IA32_SUPPORT)) {
	}
	if(defined(&CONFIG_PERFMON)) {
	}
	eval 'sub ia64_fph_enable () {
	    eval q( &asm  &volatile (\\";; rsm psr.dfh;; srlz.d;;\\" ::: \\"memory\\"););
	}' unless defined(&ia64_fph_enable);
	eval 'sub ia64_fph_disable () {
	    eval q( &asm  &volatile (\\";; ssm psr.dfh;; srlz.d;;\\" ::: \\"memory\\"););
	}' unless defined(&ia64_fph_disable);
	eval 'sub ia64_fc {
	    my($addr) = @_;
    	    eval q({  &asm  &volatile (\\"fc %0\\" :: \\"r\\"($addr) : \\"memory\\"); });
	}' unless defined(&ia64_fc);
	eval 'sub ia64_sync_i {
	    my($void) = @_;
    	    eval q({  &asm  &volatile (\\";; sync.i\\" ::: \\"memory\\"); });
	}' unless defined(&ia64_sync_i);
	eval 'sub ia64_srlz_i {
	    my($void) = @_;
    	    eval q({  &asm  &volatile (\\";; srlz.i ;;\\" ::: \\"memory\\"); });
	}' unless defined(&ia64_srlz_i);
	eval 'sub ia64_srlz_d {
	    my($void) = @_;
    	    eval q({  &asm  &volatile (\\";; srlz.d\\" ::: \\"memory\\"); });
	}' unless defined(&ia64_srlz_d);
	eval 'sub ia64_get_rr {
	    my($reg_bits) = @_;
    	    eval q({  &__u64  &r;  &asm  &volatile (\\"mov %0=rr[%1]\\" : \\"=r\\"( &r) : \\"r\\"($reg_bits) : \\"memory\\");  &r; });
	}' unless defined(&ia64_get_rr);
	eval 'sub ia64_set_rr {
	    my($reg_bits,$rr_val) = @_;
    	    eval q({  &asm  &volatile (\\"mov rr[%0]=%1\\" :: \\"r\\"($reg_bits), \\"r\\"($rr_val) : \\"memory\\"); });
	}' unless defined(&ia64_set_rr);
	eval 'sub ia64_get_dcr {
	    my($void) = @_;
    	    eval q({  &__u64  &r;  &asm  &volatile (\\"mov %0=cr.dcr\\" : \\"=r\\"( &r));  &r; });
	}' unless defined(&ia64_get_dcr);
	eval 'sub ia64_set_dcr {
	    my($val) = @_;
    	    eval q({  &asm  &volatile (\\"mov cr.dcr=%0;;\\" :: \\"r\\"($val) : \\"memory\\");  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_dcr);
	eval 'sub ia64_get_lid {
	    my($void) = @_;
    	    eval q({  &__u64  &r;  &asm  &volatile (\\"mov %0=cr.lid\\" : \\"=r\\"( &r));  &r; });
	}' unless defined(&ia64_get_lid);
	eval 'sub ia64_invala {
	    my($void) = @_;
    	    eval q({  &asm  &volatile (\\"invala\\" ::: \\"memory\\"); });
	}' unless defined(&ia64_invala);
	eval 'sub ia64_clear_ic {
	    my($flags) = @_;
    	    eval q( &asm  &volatile (\\"mov %0=psr;; rsm psr.i | psr.ic;; srlz.i;;\\" : \\"=r\\"($flags) :: \\"memory\\"););
	}' unless defined(&ia64_clear_ic);
	eval 'sub ia64_get_cpuid {
	    my($regnum) = @_;
    	    eval q({  &__u64  &r;  &asm (\\"mov %0=cpuid[%r1]\\" : \\"=r\\"( &r) : \\"rO\\"($regnum));  &r; });
	}' unless defined(&ia64_get_cpuid);
	eval 'sub ia64_eoi {
	    my($void) = @_;
    	    eval q({  &asm (\\"mov cr.eoi=r0;; srlz.d;;\\" ::: \\"memory\\"); });
	}' unless defined(&ia64_eoi);
	eval 'sub ia64_set_lrr0 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile (\\"mov cr.lrr0=%0;; srlz.d\\" :: \\"r\\"($val) : \\"memory\\"); });
	}' unless defined(&ia64_set_lrr0);
	eval 'sub ia64_set_lrr1 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile (\\"mov cr.lrr1=%0;; srlz.d\\" :: \\"r\\"($val) : \\"memory\\"); });
	}' unless defined(&ia64_set_lrr1);
	eval 'sub ia64_set_pmv {
	    my($val) = @_;
    	    eval q({  &asm  &volatile (\\"mov cr.pmv=%0\\" :: \\"r\\"($val) : \\"memory\\"); });
	}' unless defined(&ia64_set_pmv);
	eval 'sub ia64_get_pmc {
	    my($regnum) = @_;
    	    eval q({  &__u64  &retval;  &asm  &volatile (\\"mov %0=pmc[%1]\\" : \\"=r\\"( &retval) : \\"r\\"($regnum));  &retval; });
	}' unless defined(&ia64_get_pmc);
	eval 'sub ia64_set_pmc {
	    my($regnum,$value) = @_;
    	    eval q({  &asm  &volatile (\\"mov pmc[%0]=%1\\" :: \\"r\\"($regnum), \\"r\\"($value)); });
	}' unless defined(&ia64_set_pmc);
	eval 'sub ia64_get_pmd {
	    my($regnum) = @_;
    	    eval q({  &__u64  &retval;  &asm  &volatile (\\"mov %0=pmd[%1]\\" : \\"=r\\"( &retval) : \\"r\\"($regnum));  &retval; });
	}' unless defined(&ia64_get_pmd);
	eval 'sub ia64_set_pmd {
	    my($regnum,$value) = @_;
    	    eval q({  &asm  &volatile (\\"mov pmd[%0]=%1\\" :: \\"r\\"($regnum), \\"r\\"($value)); });
	}' unless defined(&ia64_set_pmd);
	eval 'sub current_text_addr () {
	    eval q(({  &void * &_pc;  &asm  &volatile (\\"mov %0=ip\\" : \\"=r\\" ( &_pc));  &_pc; }));
	}' unless defined(&current_text_addr);
	eval 'sub THREAD_SIZE () { &IA64_STK_OFFSET;}' unless defined(&THREAD_SIZE);
	eval 'sub alloc_task_struct () {
	    eval q((  &__get_free_pages( &GFP_KERNEL,  &IA64_TASK_STRUCT_LOG_NUM_PAGES)));
	}' unless defined(&alloc_task_struct);
	eval 'sub free_task_struct {
	    my($p) = @_;
    	    eval q( &free_pages(($p),  &IA64_TASK_STRUCT_LOG_NUM_PAGES));
	}' unless defined(&free_task_struct);
	eval 'sub get_task_struct {
	    my($tsk) = @_;
    	    eval q( &atomic_inc( &virt_to_page($tsk)-> &count));
	}' unless defined(&get_task_struct);
	eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
	eval 'sub ia64_get_ivr {
	    my($void) = @_;
    	    eval q({  &__u64  &r;  &asm  &volatile (\\"srlz.d;; mov %0=cr.ivr;; srlz.d;;\\" : \\"=r\\"( &r));  &r; });
	}' unless defined(&ia64_get_ivr);
	eval 'sub ia64_set_tpr {
	    my($val) = @_;
    	    eval q({  &asm  &volatile (\\"mov cr.tpr=%0\\" :: \\"r\\"($val)); });
	}' unless defined(&ia64_set_tpr);
	eval 'sub ia64_get_tpr {
	    my($void) = @_;
    	    eval q({  &__u64  &r;  &asm  &volatile (\\"mov %0=cr.tpr\\" : \\"=r\\"( &r));  &r; });
	}' unless defined(&ia64_get_tpr);
	eval 'sub ia64_set_irr0 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov cr.irr0=%0;;\\" :: \\"r\\"($val) : \\"memory\\");  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_irr0);
	eval 'sub ia64_get_irr0 {
	    my($void) = @_;
    	    eval q({  &__u64  &val;  &asm  &volatile(\\"mov %0=cr.irr0\\" : \\"=r\\"( &val));  &val; });
	}' unless defined(&ia64_get_irr0);
	eval 'sub ia64_set_irr1 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov cr.irr1=%0;;\\" :: \\"r\\"($val) : \\"memory\\");  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_irr1);
	eval 'sub ia64_get_irr1 {
	    my($void) = @_;
    	    eval q({  &__u64  &val;  &asm  &volatile(\\"mov %0=cr.irr1\\" : \\"=r\\"( &val));  &val; });
	}' unless defined(&ia64_get_irr1);
	eval 'sub ia64_set_irr2 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov cr.irr2=%0;;\\" :: \\"r\\"($val) : \\"memory\\");  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_irr2);
	eval 'sub ia64_get_irr2 {
	    my($void) = @_;
    	    eval q({  &__u64  &val;  &asm  &volatile(\\"mov %0=cr.irr2\\" : \\"=r\\"( &val));  &val; });
	}' unless defined(&ia64_get_irr2);
	eval 'sub ia64_set_irr3 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov cr.irr3=%0;;\\" :: \\"r\\"($val) : \\"memory\\");  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_irr3);
	eval 'sub ia64_get_irr3 {
	    my($void) = @_;
    	    eval q({  &__u64  &val;  &asm  &volatile (\\"mov %0=cr.irr3\\" : \\"=r\\"( &val));  &val; });
	}' unless defined(&ia64_get_irr3);
	eval 'sub ia64_get_gp {
	    my($void) = @_;
    	    eval q({  &__u64  &val;  &asm (\\"mov %0=gp\\" : \\"=r\\"( &val));  &val; });
	}' unless defined(&ia64_get_gp);
	if(defined(&SMART_COMPILER)) {
	    eval 'sub ia64_rotr {
	        my($w,$n) = @_;
    		eval q(({  &__u64  &_w = ($w),  &_n = ($n); ( &_w >>  &_n) | ( &_w << (64-  &_n)); }));
	    }' unless defined(&ia64_rotr);
	} else {
	    eval 'sub ia64_rotr {
	        my($w,$n) = @_;
    		eval q(({  &__u64  &result;  &asm (\\"shrp %0=%1,%1,%2\\" : \\"=r\\"( &result) : \\"r\\"($w), \\"i\\"($n));  &result; }));
	    }' unless defined(&ia64_rotr);
	}
	eval 'sub ia64_rotl {
	    my($w,$n) = @_;
    	    eval q( &ia64_rotr(($w),(64)-($n)));
	}' unless defined(&ia64_rotl);
	eval 'sub ia64_thash {
	    my($addr) = @_;
    	    eval q({  &__u64  &result;  &asm (\\"thash %0=%1\\" : \\"=r\\"( &result) : \\"r\\" ($addr));  &result; });
	}' unless defined(&ia64_thash);
    }
}
1;
