require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_SYSTEM_H)) {
    eval 'sub _ASM_IA64_SYSTEM_H () {1;}' unless defined(&_ASM_IA64_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/page.ph';
    eval 'sub KERNEL_START () {( &PAGE_OFFSET + 68*1024*1024);}' unless defined(&KERNEL_START);
    eval 'sub IVT_ADDR () {( &KERNEL_START);}' unless defined(&IVT_ADDR);
    eval 'sub IVT_END_ADDR () {( &KERNEL_START + 0x8000);}' unless defined(&IVT_END_ADDR);
    eval 'sub ZERO_PAGE_ADDR () { &PAGE_ALIGN( &IVT_END_ADDR);}' unless defined(&ZERO_PAGE_ADDR);
    eval 'sub SWAPPER_PGD_ADDR () {( &ZERO_PAGE_ADDR + 1* &PAGE_SIZE);}' unless defined(&SWAPPER_PGD_ADDR);
    eval 'sub GATE_ADDR () {(0xa000000000000000 +  &PAGE_SIZE);}' unless defined(&GATE_ADDR);
    eval 'sub PERCPU_ADDR () {(0xa000000000000000 + 2* &PAGE_SIZE);}' unless defined(&PERCPU_ADDR);
    if(defined( &CONFIG_ITANIUM_B0_SPECIFIC) || defined( &CONFIG_ITANIUM_B1_SPECIFIC)) {
	eval 'sub IA64_SEMFIX_INSN () { &mf;;}' unless defined(&IA64_SEMFIX_INSN);
	eval 'sub IA64_SEMFIX () {"mf;";}' unless defined(&IA64_SEMFIX);
    } else {
	eval 'sub IA64_SEMFIX_INSN () {1;}' unless defined(&IA64_SEMFIX_INSN);
	eval 'sub IA64_SEMFIX () {"";}' unless defined(&IA64_SEMFIX);
    }
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	require 'linux/types.ph';
	eval 'sub ia64_insn_group_barrier {
	    my($void) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&ia64_insn_group_barrier);
	eval 'sub mb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	}
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    my($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_wmb);
	if(defined(&CONFIG_IA64_DEBUG_IRQ)) {
	    eval 'sub local_irq_save {
	        my($x) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        my($x) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_restore);
	} else {
	    eval 'sub local_irq_save {
	        my($x) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        my($x) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&local_irq_restore);
	}
	eval 'sub local_irq_enable () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_irq_enable);
	eval 'sub __cli () {
	    eval q( &local_irq_disable ());
	}' unless defined(&__cli);
	eval 'sub __save_flags {
	    my($flags) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__save_flags);
	eval 'sub __save_and_cli {
	    my($flags) = @_;
    	    eval q( &local_irq_save($flags));
	}' unless defined(&__save_and_cli);
	eval 'sub save_and_cli {
	    my($flags) = @_;
    	    eval q( &__save_and_cli($flags));
	}' unless defined(&save_and_cli);
	eval 'sub __sti () {
	    eval q( &local_irq_enable ());
	}' unless defined(&__sti);
	eval 'sub __restore_flags {
	    my($flags) = @_;
    	    eval q( &local_irq_restore($flags));
	}' unless defined(&__restore_flags);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub cli () {
	        eval q( &__global_cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__global_sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($flags) = @_;
    		eval q((($flags) =  &__global_save_flags()));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        my($flags) = @_;
    		eval q( &__global_restore_flags($flags));
	    }' unless defined(&restore_flags);
	} else {
	    eval 'sub cli () {
	        eval q( &__cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($flags) = @_;
    		eval q( &__save_flags($flags));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        my($flags) = @_;
    		eval q( &__restore_flags($flags));
	    }' unless defined(&restore_flags);
	}
	eval 'sub IA64_FETCHADD {
	    my($tmp,$v,$n,$sz) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&IA64_FETCHADD);
	eval 'sub ia64_fetch_and_add {
	    my($i,$v) = @_;
    	    eval q(({  &__u64  &_tmp;  &volatile  &__typeof__(*($v)) * &_v = ($v);  &switch ($i) {  &case -16:  &IA64_FETCHADD( &_tmp,  &_v, -16, $sizeof{($v)});  &break;  &case -8:  &IA64_FETCHADD( &_tmp,  &_v, -8, $sizeof{($v)});  &break;  &case -4:  &IA64_FETCHADD( &_tmp,  &_v, -4, $sizeof{($v)});  &break;  &case -1:  &IA64_FETCHADD( &_tmp,  &_v, -1, $sizeof{($v)});  &break;  &case 1:  &IA64_FETCHADD( &_tmp,  &_v, 1, $sizeof{($v)});  &break;  &case 4:  &IA64_FETCHADD( &_tmp,  &_v, 4, $sizeof{($v)});  &break;  &case 8:  &IA64_FETCHADD( &_tmp,  &_v, 8, $sizeof{($v)});  &break;  &case 16:  &IA64_FETCHADD( &_tmp,  &_v, 16, $sizeof{($v)});  &break;  &default:  &_tmp =  &__bad_increment_for_ia64_fetch_and_add();  &break; } ( &__typeof__(*$v)) ( &_tmp + ($i)); }));
	}' unless defined(&ia64_fetch_and_add);
	eval 'sub __xchg {
	    my($x,$ptr,$size) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q((( &__typeof__(*))  &__xchg ( ($x), ($ptr), $sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	eval 'sub ia64_cmpxchg {
	    my($sem,$ptr,$old,$new,$size) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&ia64_cmpxchg);
	eval 'sub cmpxchg_acq {
	    my($ptr,$o,$n) = @_;
    	    eval q( &ia64_cmpxchg(\\"acq\\", ($ptr), ($o), ($n), $sizeof{($ptr)}));
	}' unless defined(&cmpxchg_acq);
	eval 'sub cmpxchg_rel {
	    my($ptr,$o,$n) = @_;
    	    eval q( &ia64_cmpxchg(\\"rel\\", ($ptr), ($o), ($n), $sizeof{($ptr)}));
	}' unless defined(&cmpxchg_rel);
	eval 'sub cmpxchg {
	    my($ptr,$o,$n) = @_;
    	    eval q( &cmpxchg_acq($ptr,$o,$n));
	}' unless defined(&cmpxchg);
	if(defined(&CONFIG_IA64_DEBUG_CMPXCHG)) {
	    eval 'sub CMPXCHG_BUGCHECK_DECL () {\'int\'  &_cmpxchg_bugcheck_count = 128;;}' unless defined(&CMPXCHG_BUGCHECK_DECL);
	    eval 'sub CMPXCHG_BUGCHECK {
	        my($v) = @_;
    		eval q( &do {  &if ( &_cmpxchg_bugcheck_count-- <= 0) {  &void * &ip;  &extern \'int\'  &printk( &const \'char\' * &fmt, ...);  &asm (\\"mov %0=ip\\" : \\"=r\\"( &ip));  &printk(\\"CMPXCHG_BUGCHECK: stuck at %p on word %p\\\\n\\",  &ip, ($v));  &break; } }  &while (0));
	    }' unless defined(&CMPXCHG_BUGCHECK);
	} else {
	    eval 'sub CMPXCHG_BUGCHECK_DECL () {1;}' unless defined(&CMPXCHG_BUGCHECK_DECL);
	    eval 'sub CMPXCHG_BUGCHECK {
	        my($v) = @_;
    		eval q();
	    }' unless defined(&CMPXCHG_BUGCHECK);
	}
    }
}
1;
