require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_UACCESS_H)) {
    eval 'sub _ASM_IA64_UACCESS_H () {1;}' unless defined(&_ASM_IA64_UACCESS_H);
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    require 'asm/pgtable.ph';
    eval 'sub KERNEL_DS () {(( &mm_segment_t) { ~0 });}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () {(( &mm_segment_t) {  &TASK_SIZE-1});}' unless defined(&USER_DS);
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( ($current->{addr_limit})));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( ($current->{addr_limit}) = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __access_ok {
        my($addr,$size,$segment) = @_;
	    eval q(( <= . &seg  && (. &seg ==  ($KERNEL_DS->{seg}) ||  &rgn_offset( ($addr)) <  &RGN_MAP_LIMIT)));
    }' unless defined(&__access_ok);
    eval 'sub access_ok {
        my($type,$addr,$size) = @_;
	    eval q( &__access_ok(($addr),($size), &get_fs()));
    }' unless defined(&access_ok);
    eval 'sub verify_area {
        my($type,$addr,$size) = @_;
	    eval q({  &access_ok($type,$addr,$size) ? 0: - &EFAULT; });
    }' unless defined(&verify_area);
    eval 'sub put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_check(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}, &get_fs()));
    }' unless defined(&put_user);
    eval 'sub get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_check(($x),($ptr),$sizeof{($ptr)}, &get_fs()));
    }' unless defined(&get_user);
    eval 'sub __put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub __get_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({  &register  &long __gu_err asm (\\"r8\\") = 0;  &register  &long __gu_val asm (\\"r9\\") = 0;  &switch ($size) {  &case 1:  &__get_user_8($ptr);  &break;  &case 2:  &__get_user_16($ptr);  &break;  &case 4:  &__get_user_32($ptr);  &break;  &case 8:  &__get_user_64($ptr);  &break;  &default:  &__get_user_unknown();  &break; } ($x) = ( &__typeof__(*($ptr)))  &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        my($x,$ptr,$size,$segment) = @_;
	    eval q(({  &register  &long __gu_err asm (\\"r8\\") = - &EFAULT;  &register  &long __gu_val asm (\\"r9\\") = 0;  &const  &__typeof__(*) * &__gu_addr = ;  &if ( &__access_ok( &__gu_addr,$size,$segment)) {  &__gu_err = 0;  &switch ($size) {  &case 1:  &__get_user_8( &__gu_addr);  &break;  &case 2:  &__get_user_16( &__gu_addr);  &break;  &case 4:  &__get_user_32( &__gu_addr);  &break;  &case 8:  &__get_user_64( &__gu_addr);  &break;  &default:  &__get_user_unknown();  &break; } } ($x) = ( &__typeof__(*($ptr)))  &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_check);
    eval 'sub __m {
        my($x) = @_;
	    eval q((*($x)));
    }' unless defined(&__m);
    if((defined(&__GNUC__) ? &__GNUC__ : undef) >= 3) {
	eval 'sub GAS_HAS_LOCAL_TAGS () {1;}' unless defined(&GAS_HAS_LOCAL_TAGS);
    }
    if(defined(&GAS_HAS_LOCAL_TAGS)) {
	eval 'sub _LL () {"[1:]";}' unless defined(&_LL);
    } else {
	eval 'sub _LL () {"1:";}' unless defined(&_LL);
    }
    eval 'sub __get_user_64 {
        my($addr) = @_;
	    eval q( &asm (\\"\\\\n\\" &_LL\\"\\\\tld8 %0=%2%P2\\\\t// %0 and %1 get overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)+4\\\\n\\"  &_LL : \\"=r\\"( &__gu_val), \\"=r\\"( &__gu_err) : \\"m\\"( &__m($addr)), \\"1\\"( &__gu_err)););
    }' unless defined(&__get_user_64);
    eval 'sub __get_user_32 {
        my($addr) = @_;
	    eval q( &asm (\\"\\\\n\\" &_LL\\"\\\\tld4 %0=%2%P2\\\\t// %0 and %1 get overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)+4\\\\n\\"  &_LL : \\"=r\\"( &__gu_val), \\"=r\\"( &__gu_err) : \\"m\\"( &__m($addr)), \\"1\\"( &__gu_err)););
    }' unless defined(&__get_user_32);
    eval 'sub __get_user_16 {
        my($addr) = @_;
	    eval q( &asm (\\"\\\\n\\" &_LL\\"\\\\tld2 %0=%2%P2\\\\t// %0 and %1 get overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)+4\\\\n\\"  &_LL : \\"=r\\"( &__gu_val), \\"=r\\"( &__gu_err) : \\"m\\"( &__m($addr)), \\"1\\"( &__gu_err)););
    }' unless defined(&__get_user_16);
    eval 'sub __get_user_8 {
        my($addr) = @_;
	    eval q( &asm (\\"\\\\n\\" &_LL\\"\\\\tld1 %0=%2%P2\\\\t// %0 and %1 get overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)+4\\\\n\\"  &_LL : \\"=r\\"( &__gu_val), \\"=r\\"( &__gu_err) : \\"m\\"( &__m($addr)), \\"1\\"( &__gu_err)););
    }' unless defined(&__get_user_8);
    eval 'sub __put_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({  &register  &long __pu_err asm (\\"r8\\") = 0;  &switch ($size) {  &case 1:  &__put_user_8($x,$ptr);  &break;  &case 2:  &__put_user_16($x,$ptr);  &break;  &case 4:  &__put_user_32($x,$ptr);  &break;  &case 8:  &__put_user_64($x,$ptr);  &break;  &default:  &__put_user_unknown();  &break; }  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        my($x,$ptr,$size,$segment) = @_;
	    eval q(({  &register  &long __pu_err asm (\\"r8\\") = - &EFAULT;  &__typeof__(*) * &__pu_addr = ;  &if ( &__access_ok( &__pu_addr,$size,$segment)) {  &__pu_err = 0;  &switch ($size) {  &case 1:  &__put_user_8($x, &__pu_addr);  &break;  &case 2:  &__put_user_16($x, &__pu_addr);  &break;  &case 4:  &__put_user_32($x, &__pu_addr);  &break;  &case 8:  &__put_user_64($x, &__pu_addr);  &break;  &default:  &__put_user_unknown();  &break; } }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_64 {
        my($x,$addr) = @_;
	    eval q( &asm  &volatile ( \\"\\\\n\\" &_LL\\"\\\\tst8 %1=%r2%P1\\\\t// %0 gets overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)\\\\n\\"  &_LL : \\"=r\\"( &__pu_err) : \\"m\\"( &__m($addr)), \\"rO\\"($x), \\"0\\"( &__pu_err)));
    }' unless defined(&__put_user_64);
    eval 'sub __put_user_32 {
        my($x,$addr) = @_;
	    eval q( &asm  &volatile ( \\"\\\\n\\" &_LL\\"\\\\tst4 %1=%r2%P1\\\\t// %0 gets overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)\\\\n\\"  &_LL : \\"=r\\"( &__pu_err) : \\"m\\"( &__m($addr)), \\"rO\\"($x), \\"0\\"( &__pu_err)));
    }' unless defined(&__put_user_32);
    eval 'sub __put_user_16 {
        my($x,$addr) = @_;
	    eval q( &asm  &volatile ( \\"\\\\n\\" &_LL\\"\\\\tst2 %1=%r2%P1\\\\t// %0 gets overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)\\\\n\\"  &_LL : \\"=r\\"( &__pu_err) : \\"m\\"( &__m($addr)), \\"rO\\"($x), \\"0\\"( &__pu_err)));
    }' unless defined(&__put_user_16);
    eval 'sub __put_user_8 {
        my($x,$addr) = @_;
	    eval q( &asm  &volatile ( \\"\\\\n\\" &_LL\\"\\\\tst1 %1=%r2%P1\\\\t// %0 gets overwritten by exception handler\\\\n\\" \\"\\\\t.xdata4 \\\\\\"__ex_table\\\\\\", @gprel(1b), @gprel(1f)\\\\n\\"  &_LL : \\"=r\\"( &__pu_err) : \\"m\\"( &__m($addr)), \\"rO\\"($x), \\"0\\"( &__pu_err)));
    }' unless defined(&__put_user_8);
    eval 'sub __copy_to_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_user(($to), ($from), ($n)));
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_from_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_user(($to), ($from), ($n)));
    }' unless defined(&__copy_from_user);
    eval 'sub copy_to_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_tofrom_user(($to), ($from), ($n), 1));
    }' unless defined(&copy_to_user);
    eval 'sub copy_from_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_tofrom_user(($to), ($from), ($n), 0));
    }' unless defined(&copy_from_user);
    eval 'sub __copy_tofrom_user {
        my($to,$from,$n,$check_to) = @_;
	    eval q(({  &void * &__cu_to = ;  &const  &void * &__cu_from = ; \'long __cu_len\' = ;  &if ( &__access_ok( (($check_to) ?  &__cu_to :  &__cu_from),  &__cu_len,  &get_fs())) {  &__cu_len =  &__copy_user( &__cu_to,  &__cu_from,  &__cu_len); }  &__cu_len; }));
    }' unless defined(&__copy_tofrom_user);
    eval 'sub __clear_user {
        my($to,$n) = @_;
	    eval q(({  &__do_clear_user($to,$n); }));
    }' unless defined(&__clear_user);
    eval 'sub clear_user {
        my($to,$n) = @_;
	    eval q(({ \'unsigned long __cu_len\' = ;  &if ( &__access_ok( $to,  &__cu_len,  &get_fs())) {  &__cu_len =  &__do_clear_user($to,  &__cu_len); }  &__cu_len; }));
    }' unless defined(&clear_user);
    eval 'sub strncpy_from_user {
        my($to,$from,$n) = @_;
	    eval q(({  &const \'char\' *  &__sfu_from = ; \'long __sfu_ret\' = - &EFAULT;  &if ( &__access_ok(  &__sfu_from, 0,  &get_fs()))  &__sfu_ret =  &__strncpy_from_user(($to),  &__sfu_from, ($n));  &__sfu_ret; }));
    }' unless defined(&strncpy_from_user);
    eval 'sub strlen_user {
        my($str) = @_;
	    eval q(({  &const \'char\' * &__su_str = ; \'unsigned long __su_ret\' = 0;  &if ( &__access_ok(  &__su_str, 0,  &get_fs()))  &__su_ret =  &__strlen_user( &__su_str);  &__su_ret; }));
    }' unless defined(&strlen_user);
    eval 'sub strnlen_user {
        my($str, $len) = @_;
	    eval q(({  &const \'char\' * &__su_str = ; \'unsigned long __su_ret\' = 0;  &if ( &__access_ok(  &__su_str, 0,  &get_fs()))  &__su_ret =  &__strnlen_user( &__su_str, $len);  &__su_ret; }));
    }' unless defined(&strnlen_user);
}
1;
